<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */

const _JEXEC = 1;

$root = dirname(dirname(dirname(__DIR__))) ;

// Load system defines
if (file_exists($root . '/defines.php'))
{
	require_once $root . '/defines.php';
}

if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $root);
	require_once JPATH_BASE . '/includes/defines.php';
}

require_once JPATH_LIBRARIES . '/import.legacy.php';
require_once JPATH_LIBRARIES . '/cms.php';
require_once JPATH_CONFIGURATION . '/configuration.php';
require_once JPATH_CONFIGURATION . '/components/com_tablebooking/helpers/tbrestaurant.php';
require_once JPATH_CONFIGURATION . '/components/com_tablebooking/helpers/tbdisplay.php';
require_once JPATH_CONFIGURATION . '/components/com_tablebooking/helpers/tbparams.php';


//class TbCron extends JApplicationCli
class TbCron
{

	public function doExecute()
	{
		$list = $this->getCrons();

		if ($list)
		{
			foreach ($list as $cron)
			{
    			$params = TbRestaurant::getInstance($cron->restaurant)->getParams();
				$bookings = $this->getBookingList($cron);

				if ($bookings)
				{
					$notification = new stdclass;
					$notification->sender  = JFactory::getConfig()->get('mailfrom');
					$notification->fromname = JFactory::getConfig()->get('fromname');

					foreach ($bookings as $booking)
					{
                        $notification->subject =
                        	TbDisplay::stripCronTags(
                        		$cron->cron_subject,
                        		$booking,
                        		$params
                        	);

                        $notification->message =
                        	TbDisplay::stripCronTags(
                        	$cron->cron_message,
                        	$booking,
                        	$params
                    	);

						$notification->to = $booking->email;
						print_r($notification);

						try
						{
							$this->sendNotification($notification);
						}
						catch (phpmailerException $e)
						{
							print($e->getMessage());
						}
					}
				}
			}
		}
	}


	private function getCrons()
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from('#__tbb_crons');

		$db->setQuery($query);
		return $db->loadObjectList();
	}


	private function getBookingList($cron)
	{
		$db = JFactory::getDbo();
		$interval = $cron->moment_in_time == 0 ? '+' . $cron->x_days : '-' . $cron->x_days;
		$query = $db->getQuery(true);
		$query->select('places, name, email, bookdate, bookstart, bookend, phone');
		$query->from('#__tbb_bookings');
		$query->where('bookdate = DATE_ADD(CURDATE(),INTERVAL ' . $interval . ' DAY)');
		$query->where('status = ' . $cron->reservation_status);
		$query->where('restaurant = ' . $cron->restaurant);
		$db->setQuery($query);
		return $db->loadObjectList();
	}


	private function sendNotification($notification)
	{
		JFactory::getMailer()->sendMail($notification->sender, $notification->fromname, $notification->to, $notification->subject, $notification->message);
	}


}

//JApplicationCli::getInstance('Tbcron')->execute();
$cron = new TbCron();
$cron->doExecute();
