<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');


class TableBookingModelCron extends JModelAdmin
{
	protected $text_prefix = 'COM_TABLEBOOKING_TABLE';

	public function getTable($type = 'Cron', $prefix = 'TableBookingTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}


	public function getForm($data = array(), $loadData = true)
	{
		// Get the form.
		$form = $this->loadForm('com_tablebooking.cron', 'cron', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}
		
		return $form;
	}

	protected function loadFormData()
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_tablebooking.edit.cron.data', array());
		
		if (empty($data)) {
			$data = $this->getItem();
		}
		
		return $data;
	}

	public function save($data) 
	{	
		$user = TbUser::getInstance();
		if ($user->work->position == 2)
		{
			$data['restaurant'] = $user->work->restaurant->id;
			parent::save($data);
			return true;
		}
		return false;
	}

}
?>
