<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JFormHelper::loadFieldClass('list');

class JFormFieldSchedulestart extends JFormFieldList {

	public function getOptions()
	{
		$selected = JModelLegacy::getInstance('Bookings','TablebookingModel')->getState('filter.bookings.datephp');
		$restaurant = TbUser::getInstance()->work->restaurant;
		if ($this->form->getValue('bookdate'))
		{
			$date =  TbSchedule::getDate($this->form->getValue('bookdate'));
		}
		else
		{
			$date = ($selected) ? TbSchedule::getDate($selected) : TbSchedule::getDate('now');
		}


		// first let's see if a schedule is set for the date
		$schedule = $restaurant->getSchedule($date);

		// if a schedule for that certain date doesn't exist default to the schedule for the week day
		if (!$schedule->isSet)
		{
			$schedule = $restaurant->getSchedule($date->__get('dayofweek'));
		}
		return $schedule->working ? $schedule->getHours(true) : array(''=>'-');
	}
}
?>
