<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.modeladmin');

class TableBookingModelSpecial extends JModelAdmin
{

	protected $text_prefix = '';


	public function getForm($data = array(), $loadData = true)
	{
		// Get the form.
		$form = $this->loadForm('com_tablebooking.special', 'special', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}
		
		return $form;
	}

	protected function loadFormData()
	{
		$id = JRequest::getVar('id','','','base64');
		$data = array();

		if ($id) 
		{
			$id = base64_decode($id);
			$sched  = $this->getSpecialDay($id);
			$data['selecteddate'] = $id;
			$data['date'] = TbDisplay::showDate($id, TbUser::getInstance()->work->restaurant->getParams()->dateformat);
			$data['addnewinterval'] = $sched->intervals;
			$data['status'] = $sched->working;
		}

		return $data;
	}

	protected function getSpecialDay($key)
	{
		$schedule = TbUser::getInstance()->work->restaurant->schedule;
		if ($schedule)
		{
			$records = unserialize($schedule);	
			if (isset($records[$key])) 
			{
				return $records[$key];
			}
			else 
			{
				return array();
			}
		}
		else 
		{
			return array();
		}
	}


	
}
?>
