<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class TableBookingViewBooking extends JViewLegacy
{
	protected $form;
	protected $state;
	protected $item;
	protected $restaurant;
	protected $selected;

	public function display($tpl = null)
	{
		
		if (!TbUser::getInstance()->isAuthorized('management')) 
		{
			JFactory::getApplication()->redirect('index.php?option=com_users');
			return false;
		}
		
		$this->form = $this->get('Form');
		$this->state = $this->get('State');
		$this->item = $this->get('Item'); 
		$this->restaurant = TbUser::getInstance()->work->restaurant;
		$this->selected = $this->item->id ? $this->get('Selected') : null;
		
		if ($this->item->id && $this->restaurant->id != $this->item->restaurant)
		{
			return false;
		}

		$this->addResources();
		parent::display($tpl);
	}

	public function addResources() {	
		
		$scheme = JUri::getInstance()->getScheme();

		JHtml::stylesheet( 'components/com_tablebooking/assets/css/bootstrap.css' );
		JHtml::stylesheet( 'components/com_tablebooking/assets/css/style.css' );
		JHtml::stylesheet( 'components/com_tablebooking/assets/medial/style.css' );
		JHtml::script( 'components/com_tablebooking/assets/js/tbb.js' );
		JHtml::script( 'components/com_tablebooking/assets/js/calendar.js' );
	}
}
?>
