<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class TableBookingViewManagement extends JViewLegacy
{

	protected $restaurant;
	protected $arrangements;

	public function display($tpl = null) {

		if (!TbUser::getInstance()->isAuthorized('management'))
        {
            $return = base64_encode('index.php?option=com_tablebooking&view=management');
			JFactory::getApplication()->redirect('index.php?option=com_users&return=' . $return);
			return false;
		}

		$this->restaurant = TbUser::getInstance()->work->restaurant;
        $this->arrangements =
            TbDisplay::getTablesArrangement($this->restaurant->getTables());
		$this->addResources();

		parent::display($tpl);
	}


	public function addResources() {

		$scheme = JUri::getInstance()->getScheme();

		JHtml::stylesheet('components/com_tablebooking/assets/css/bootstrap.css');
		JHtml::stylesheet('components/com_tablebooking/assets/css/style.css');
		JHtml::stylesheet('components/com_tablebooking/assets/medial/style.css');
		JHtml::script('components/com_tablebooking/assets/js/tbb.js');
		JHtml::script('components/com_tablebooking/assets/js/calendar.js');
	}

}
