<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

?>
<div id="tablebooking">

    <div class="modal fade" id="div-error-message">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" onclick="tbb.hideErrorMessage();">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title"><?php echo JText::_('COM_TABLEBOOKING_ERROR_OCCURED');?></h4>
                </div>
                <div class="modal-body">
                    <span id="error-message"></span>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" onclick="tbb.hideErrorMessage();">
                        <?php echo JText::_('COM_TABLEBOOKING_CLOSE');?>
                    </button>
                </div>
            </div>
        </div>
    </div>

    <form
        action="<?php echo JRoute::_('index.php?option=com_tablebooking&view=search', false);?>"
        method="post" name="adminForm" id="adminForm" class="form-inline">

		<!-- initial serch details (date, time, places) -->
		<div id="search-form" class="form-step step-active">
			<div id="tb-controls">
				<div class="col-md-12 pull-left">
                    <h3><i class="ico ico-bookings"></i>
                    <?php echo JText::_('COM_TABLEBOOKING_SEARCH_BOOKING');?>
                    </h3>
				</div>
			</div>

			<div class="row center">
				<?php echo $this->form->getInput('restaurant');?>
			</div>

			<div class="clearfix"><p></p></div>

            <?php $classn = $this->restaurant->getParams()
                                ->booking_length == 0 ? 'fgp5' : 'fgp4' ;?>
			<div class="form-group" style="position:relative;">
                    <div class="fgp <?php echo $classn;?>">
                        <?php echo $this->form->getInput('calendar'); ?></div>
                    <div class="fgp <?php echo $classn;?>">
                        <?php echo $this->form->getInput('bookstart'); ?></div>
                    <?php if ($this->restaurant->getParams()
                                                    ->booking_length == 0) {?>
                    <div class="fgp <?php echo $classn;?>">
                        <?php echo $this->form->getInput('bookend'); ?></div>
					<?php } ?>
                    <div class="fgp <?php echo $classn;?>">
                        <?php echo $this->form->getInput('places');  ?></div>
                    <div class="fgp <?php echo $classn;?>">
                        <button type="button"
                                class="btn btn-primary"
                                onclick="tbb.getTables();return false;">
                        <?php echo JText::_('COM_TABLEBOOKING_SEARCH_TABLE') ;?>
                        </button>
                    </div>
			</div>

			<div class="clearfix"><p></p></div>

			<div class="row">
				<div class="col-md-12">
                    <h4 id="alth" style="display: none;">
                        <?php echo JText::_('COM_TABLEBOOKING_ALTERNATIVES');?>
                    </h4>
					<div id="alternatives" style="display:none;"></div>
				</div>
			</div>

            <?php $fields = $this->form->getFieldset('details-hidden');
                    foreach ($fields as $field) {echo $field->input;} ?>
		</div>
		<!-- /initial serch details (date, time, places) -->

		<?php if ($this->restaurant->getParams()->allow_user_choose_table) {?>
		<!-- possible tables -->
		<div id="search-results-map" class="form-step step-inactive">
			<div id="tb-controls">
				<div class="col-md-12 pull-left">
                    <h3><i class="ico ico-tables"></i>
                        <?php echo JText::_('COM_TABLEBOOKING_CHOOSE_TABLE');?>
                    </h3>
				</div>
			</div>

            <div class="row">
                <div class="col-md-12">
                    <div class="col-md-6">
                        <span class="legend available"></span>
                        <?php echo JText::_('COM_TABLEBOOKING_AVAILABLE');?>
                    </div>
                    <div class="col-md-6">
                        <span class="legend unavailable"></span>
                        <?php echo JText::_('COM_TABLEBOOKING_UNAVAILABLE');?>

                    </div>
                </div>
            </div>

			<div class="row">
				<div class="col-md-12">
					<div id="search-results"></div>
				</div>
			</div>
		</div>
		<!-- /possible tables -->
		<?php } ?>

		<!-- user details -->
		<div id="finish-booking" class="form-step step-inactive">
			<div id="tb-controls">
				<div class="col-md-12 pull-left">
                    <h3><i class="ico ico-user"></i>
                    <?php echo JText::_('COM_TABLEBOOKING_COMPLETE_YOUR_RESERVATION');?>
                    </h3>
				</div>
			</div>

			<div class="well fbr">
                <div class="col-md-4 col-sm-4 col-xs-4 fb">
                    <?php echo JText::_('COM_TABLEBOOKING_PERSONS');?></div>
                <div class="col-md-4 col-sm-4 col-xs-4 fb">
                    <?php echo JText::_('COM_TABLEBOOKING_DATE');?></div>
                <div class="col-md-4 col-sm-4 col-xs-4 fb">
                    <?php echo JText::_('COM_TABLEBOOKING_TIME');?></div>
				<div class="col-md-4 col-sm-4 col-xs-4" id="tbp"></div>
				<div class="col-md-4 col-sm-4 col-xs-4" id="tbd"></div>
				<div class="col-md-4 col-sm-4 col-xs-4" id="tbt"></div>
			</div>

			<div class="row">
                <?php $fields = $this->form->getFieldset('userdata');
                    foreach ($fields as $field){
                        if ($field->type != 'hidden'){?>
				<div class="col-md-12">
                    <label class="control-label col-md-4">
                        <?php echo $field->label; ?>
                    </label>
					<div class="controls cold-md-8">
						<?php echo $field->input;  ?>
					</div>
				</div>
				<?php } else { ?>
					<?php echo $field->input;  ?>
				<?php } } ?>

                <?php if ($this->restaurant->getParams()->gdpr_enable > 0) {?>
                <div class="col-md-12">
                    <label>
                    <input type="checkbox"
                        value="1"
                        name="jform[gdpr]"
                        id="jform_gdpr"
                        class="booking-form" />
                    </label>
                    <div class="gdpr_text">
                        <?php echo $this->restaurant->getParams()->gdpr_text;?>
                    </div>
                </div>
                <?php } ?>
				<div class="col-md-12">
					<p></p>
				</div>

				<div class="col-md-12">
                    <div class="col-md-12" id="tbse">
                        <?php echo JText::_('COM_TABLEBOOKING_SUCCESSFULLY_RESERVED');?>
                    </div>
                    <button id="bookit" class="btn btn-primary form-control"
                            onclick="tbb.finishReservation();return false;">
                            <i class="ico ico-accept"></i>
                            <?php echo JText::_('COM_TABLEBOOKING_RESERVE');?>
                    </button>
				</div>
			</div>
		</div>
		<!-- /user details -->

		<input type="hidden" name="timestamp" id="timestamp" value="" />
		<input type="hidden" name="task" value="" />
		<?php echo JHtml::_('form.token'); ?>
	</form>
</div>


<script type="text/javascript">
	var dat = new DateHelper();
	var utils = new MedialUtilities();
    var gdpr = <?php echo $this->restaurant->getParams()->gdpr_enable;?>;
    var disableSelection = false;

	var DateConfig = {
		fullCurrentMonth: true,
		dateFormat: '<?php echo $this->restaurant->getParams()->dateformat;?>',
		<?php if ($this->restaurant->getParams()->startcal == 1) { ?>
		weekdays: ['<?php echo JText::_("COM_TABLEBOOKING_MONDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_TUESDAY", true);?>',
		  			'<?php echo JText::_("COM_TABLEBOOKING_WEDNESDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_THURSDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FRIDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SATURDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SUNDAY", true);?>'],
		<?php } else { ?>
		weekdays: ['<?php echo JText::_("COM_TABLEBOOKING_SUNDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MONDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_TUESDAY", true);?>',
		  			'<?php echo JText::_("COM_TABLEBOOKING_WEDNESDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_THURSDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FRIDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SATURDAY", true);?>'],
		<?php } ?>
		months: ['<?php echo JText::_("COM_TABLEBOOKING_JANUARY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FEBRUARY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MARCH", true);?>',
			  '<?php echo JText::_("COM_TABLEBOOKING_APRIL", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_JUNE", true);?>',
			  '<?php echo JText::_("COM_TABLEBOOKING_JULY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_AUGUST", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SEPTEMBER", true);?>',
			  '<?php echo JText::_("COM_TABLEBOOKING_OCTOBER", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_NOVEMBER", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_DECEMBER", true);?>'],
		suffix: { 1: 'st', 2: 'nd', 3: 'rd', 21: 'st', 22: 'nd', 23: 'rd', 31: 'st' },
		defaultSuffix: 'th',
		_startCal: '<?php echo $this->restaurant->getParams()->startcal;?>',
		_restricted: <?php echo json_encode($this->restricted);?>,
		_allowed: <?php echo json_encode($this->allowed);?>,
	};

	new datepickr('jform_calendar', 'jform_calendar', DateConfig);

	var date={workingHours:new Array,workingHoursCorrespondent:new Array,timestamp:function(){return document.getElementById("timestamp").value},selectedDate:function(){return dat.toCustom(document.getElementById("timestamp").value,DateConfig.dateFormat)},phpDate:function(){return dat.toCustom(document.getElementById("timestamp").value,"Y-m-d")},reset:function(){date.workingHoursCorrespondent=new Array,date.workingHours=new Array}};

	var tbb = {

		nextStep : function() {
			var steps = document.getElementsByClassName('form-step'); for(var i=0;i<steps.length;i++)if(utils.hasClass(steps[i],"step-active")){utils.removeClass(steps[i+1],"step-inactive"),utils.addClass(steps[i+1],"step-active");break}
		},

		changeRestaurant : function() {
			var newR = document.getElementById('jform_restaurant').value;
            var url = '<?php echo JUri::root();?>'+
                'index.php?option=com_tablebooking&task=search.changeRestaurant';
			var params = 'info[id]=' + newR + '&<?php echo JFactory::getSession()->getFormToken();?>=1';
			utils.makeAjaxCall(url,'POST',params,function(data) {
				document.adminForm.submit();
			});
		},

		setWorkingHours : function() {

			var restaurant = document.getElementById('jform_restaurant').value;
            var url = '<?php echo JUri::root();?>'+
                'index.php?option=com_tablebooking&task=search.getWorkingHours';
			var params = 'info[restaurant]=' + restaurant + '&info[date]=' + date.phpDate() + '&<?php echo JFactory::getSession()->getFormToken();?>=1';
			utils.makeAjaxCall(url,'POST',params,function(data) {
				var response = JSON.parse(data);
				if (!response.error) {
					var sel = document.getElementById('jform_bookstart');
					sel.options.length = 0;
					var opt = document.createElement('option');
					opt.value = "-1";
					opt.innerText = '<?php echo JText::_('COM_TABLEBOOKING_BOOKINGS_START', true);?>';
					opt.innerHTML = opt.innerText;
					sel.appendChild(opt);
					sel.selectedIndex = 0;

                    var keys = Object.keys(response.hours);
                    var max = keys.length - 1;
                    var k = 0;
                    for(var i in response.hours){
                        date.workingHoursCorrespondent.push(i),date.workingHours.push(response.hours[i]);
                        if (k < max) {
                            var opt=document.createElement("option");opt.value=i,opt.innerText=response.hours[i],opt.innerHTML=opt.innerText,sel.appendChild(opt),sel.selectedIndex=0;
                            k++;
                        }
                    }
				} else {
					document.getElementById('jform_bookstart').innerHTML = '';
					tbb.displayErrorMessage(response.error);
				}
			});
		},

		<?php if (!$this->restaurant->getParams()->booking_length) {?>
		setFinishHours : function() {

			var selectedStart = document.getElementById('jform_bookstart').value;
			var sel = document.getElementById('jform_bookend');
			sel.options.length = 0;

			if (selectedStart == -1) {
				var opt = document.createElement('option');
				opt.value = '-1';
				opt.innerHTML = opt.innerText = '<?php echo JText::_('COM_TABLEBOOKING_BOOKINGS_END', false);?>';
				sel.appendChild(opt);
				sel.selectedIndex = 0;
				return;
			}

			var idx = date.workingHoursCorrespondent.indexOf(selectedStart) + 1;
			for(var i=1;i<20;i++)if(void 0!=date.workingHoursCorrespondent[idx]&&void 0!=date.workingHours[idx]){var opt=document.createElement("option");opt.value=date.workingHoursCorrespondent[idx],opt.innerHTML=opt.innerText=date.workingHours[idx],sel.appendChild(opt),sel.selectedIndex=0,idx++}
		},
		<?php } else { ?>
			setFinishHours : function() { return true; },
		<?php } ?>


		changedate : function(newdate) {
			document.getElementById("timestamp").value=dat.toTimestamp(newdate),document.getElementById("jform_bookdate").value=date.phpDate(),date.reset(),tbb.setWorkingHours(),tbb.setFinishHours();
		},


		getTables : function() {
				document.getElementById("jform_table").value='';
                disableSelection = false;
				document.getElementById("bookit").disabled=!1,document.getElementById("tbse").style.display="none";var alternatives=document.getElementById("alternatives"),restaurant=document.getElementById("jform_restaurant").value,seldate=document.getElementById("jform_bookdate").value,start=document.getElementById("jform_bookstart").value;document.getElementById("finish-booking").className="form-step step-inactive";document.getElementById("search-results-map") && (document.getElementById("search-results-map").className="form-step step-inactive");
			<?php if (!$this->restaurant->getParams()->booking_length) { ?>
			var end = document.getElementById('jform_bookend').value;
			<?php } else { ?>
			var end = Number(start) + <?php echo $this->restaurant->getParams()->booking_length; ?>;
			<?php } ?>
			var places = document.getElementById('jform_places').value;

			if (!start || start == -1) {
				return false;
			}

			if (!end || end == -1) {
				return false;
			}

			if (!restaurant || !seldate || !places) {
				return false;
			}

			// reset alternatives
			alternatives.style.display = 'none';
			alternatives.innerHTML = '';
			document.getElementById('alth').style.display = 'none';

            var url = '<?php echo JUri::root();?>'+
                'index.php?option=com_tablebooking&task=booking.getTables';
			var params = 'restaurant=' + restaurant + '&date=' + seldate + '&start=' + start + '&end=' + end + '&places=' + places + '&view=1' + '&<?php echo JFactory::getSession()->getFormToken();?>=1';
			utils.makeAjaxCall(url,'POST',params,function(data) {
				var response = JSON.parse(data);
				if (!response.error) {
					<?php if ($this->restaurant->getParams()->allow_user_choose_table) {?>
					document.getElementById('search-results').innerHTML = response.html;
					document.getElementById('jform_table').value = response.selected;
					<?php } else { ?>
					document.getElementById('jform_table').value = response.selected;
					<?php } ?>
					tbb.nextStep();
					tbb.addUserDetails();
				} else {
					if(0!=response.alternatives.length){document.getElementById("finish-booking").className="form-step step-inactive";var length=parseInt(end)-parseInt(start);document.getElementById("alth").style.display="block",alternatives.style.display="block",response.alternatives.forEach(function(a){var b=document.createElement("button");b.className="btn btn-sm alternative",b.innerHTML=a.val,b.setAttribute("onclick","tbb.setNewSearch("+a.idx+", "+length+");"),alternatives.appendChild(b)})}else tbb.displayErrorMessage(response.error);
				}
			});
		},

		clearSelTables : function() {
            disableSelection = false;
			document.getElementById("jform_table").value="";
		},

		selectTable : function(e) {
            if (disableSelection) {
                return;
            }
			tbb.clearSelTables();
            e.classList.toggle('selected');
            var result = tbb.selectionFinished(e);
            if (result) {
                document.getElementById('jform_table').value = result;
                tbb.unmarkTables(result);
                tbb.nextStep();
                tbb.addUserDetails();
                disableSelection = true;
            }
	  	},

        selectionFinished: function(e) {
            var selected = document.querySelectorAll('.available.selected');
            var places = document.getElementById('jform_places').value;
            var total = 0;
            var ids = [];
            if (selected.length == 0) {
                return false;
            }

            if (e.dataset.places >= places) {
				return e.dataset.id;
            }

            for (var i=0; i<selected.length; i++) {
                total += parseInt(selected[i].dataset.places);
                ids.push(selected[i].dataset.id);
            }

            if (total >= places) {
                return ids.join(',');
            }
            return false;
        },

		unmarkTables: function(remains) {
    		var ids = remains.split(',');
            var selected = document.querySelectorAll('.available.selected');
			selected.forEach(sel => {
    			if (ids.indexOf(sel.dataset.id) === -1) {
					sel.classList.remove('selected');
    			}
			});
		},

	  	addUserDetails : function() {
			if (!document.getElementById('jform_table').value){
				return false;
			}
			document.getElementById("finish-booking").className="form-step step-active";var idx=date.workingHoursCorrespondent.indexOf(document.getElementById("jform_bookstart").value);document.getElementById("tbp").innerHTML=document.getElementById("jform_places").value,document.getElementById("tbt").innerHTML=date.workingHours[idx],document.getElementById("tbd").innerHTML=date.selectedDate();
		},

		finishReservation : function() {
            var required=document.querySelectorAll(".booking-form.required");
            var form = document.querySelectorAll('.booking-form');
            var email=document.getElementById("jform_email").value.trim();
            document.getElementById('jform_email').value = email;

			if (tbb.formValidate(required) && tbb.validateEmail(email)) {

                if (!tbb.gdprValid()) {
                    tbb.displayErrorMessage('<?php echo JText::_('COM_TABLEBOOKING_GDPR_MUST_BE_CHECKED', true);?>');
                    return;
                } else {
                    var el = document.getElementById('jform_gdpr');
                    if (el) {
                        el.value = el.checked ? 1 : 0;
                    }
                }

                var url = '<?php echo JUri::root();?>' +
                    'index.php?option=com_tablebooking&task=booking.saveAjax&location=client';
				var params = '<?php echo JFactory::getSession()->getFormToken();?>=1';
				for(var i=0;i<form.length;i++)params+="&"+form[i].name+"="+form[i].value;
				utils.makeAjaxCall(url,'POST',params,function(data) {
					var response=JSON.parse(data);
					if (response.success == 0) {
                        tbb.displayErrorMessage(response.errors);
					} else {
                        document.getElementById("jform_table").value="",document.getElementById("jform_name").value="",document.getElementById("jform_email").value="",document.getElementById("jform_phone").value="",document.getElementById("jform_comments").value="",document.getElementById("tbse").style.display="block",document.getElementById("bookit").disabled=!0;
                        if (document.getElementById('jform_gdpr')) {
                            document.getElementById('jform_gdpr').checked = false;
                        }
					}
				});
			}
		},

		formValidate : function(form) {
			for (var i=0; i<form.length; i++) {
                if (!form[i].value) {
                    tbb.displayErrorMessage('<?php echo JText::_('COM_TABLEBOOKING_ERROR_PLEASE_COMPLETE_ALL_FIELDS', true);?>');
                    return false;
				}
			}
			return true;
		},

        displayErrorMessage : function(err) {
            document.getElementById('error-message').innerText = err;
            document.getElementById('div-error-message').classList.add('in');
        },

        hideErrorMessage: function() {
            document.getElementById('error-message').innerText = '';
            document.getElementById('div-error-message').classList.remove('in');
        },

		validateEmail: function(e) {
    		var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,8}(?:\.[a-z]{4})?)$/i;
    		return re.test(e);
		},

		setNewSearch: function(s,l) {
			document.getElementById("jform_bookstart").value=s,tbb.setFinishHours(),document.getElementById("jform_bookend")&&(document.getElementById("jform_bookend").value=s+l),tbb.getTables();
		},

        gdprValid: function() {
            if (gdpr !== 1) {
                return true;
            } else {
                return document.getElementById('jform_gdpr').checked;
            }
        },
	};

	//initialize form with current date
	window.onload = function() {
		tbb.setWorkingHours();
		document.getElementById('jform_bookdate').value = date.phpDate();
		document.getElementById('jform_places').placeholder = '<?php echo JText::_('COM_TABLEBOOKING_HOW_MANY_PEOPLE', true); ?>';
		document.getElementById("jform_bookstart").addEventListener?document.getElementById("jform_bookstart").addEventListener("change",tbb.setFinishHours):document.getElementById("jform_bookstart").attachEvent("onchange",tbb.setFinishHours);
		var days = document.getElementsByClassName('day'); for(var i=0;i<days.length;i++)days[i].addEventListener("click",function(a){if (!a.target.classList.contains('restricted')) tbb.changedate(a.target.getAttribute("data-date"))}),days[i].addEventListener("mouseover",function(a){a.target.classList.toggle('circled');}),days[i].addEventListener("mouseout",function(a){a.target.classList.toggle('circled');});
	}
</script>
